/**
 * generated by Xtext 2.32.0
 */
package no.ntnu.tdt4250.componentsdsl.componentsDSL;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Port</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link no.ntnu.tdt4250.componentsdsl.componentsDSL.Port#getName <em>Name</em>}</li>
 *   <li>{@link no.ntnu.tdt4250.componentsdsl.componentsDSL.Port#isProvided <em>Provided</em>}</li>
 *   <li>{@link no.ntnu.tdt4250.componentsdsl.componentsDSL.Port#isRequired <em>Required</em>}</li>
 * </ul>
 *
 * @see no.ntnu.tdt4250.componentsdsl.componentsDSL.ComponentsDSLPackage#getPort()
 * @model
 * @generated
 */
public interface Port extends EObject
{
  /**
   * Returns the value of the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Name</em>' attribute.
   * @see #setName(String)
   * @see no.ntnu.tdt4250.componentsdsl.componentsDSL.ComponentsDSLPackage#getPort_Name()
   * @model
   * @generated
   */
  String getName();

  /**
   * Sets the value of the '{@link no.ntnu.tdt4250.componentsdsl.componentsDSL.Port#getName <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Name</em>' attribute.
   * @see #getName()
   * @generated
   */
  void setName(String value);

  /**
   * Returns the value of the '<em><b>Provided</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Provided</em>' attribute.
   * @see #setProvided(boolean)
   * @see no.ntnu.tdt4250.componentsdsl.componentsDSL.ComponentsDSLPackage#getPort_Provided()
   * @model
   * @generated
   */
  boolean isProvided();

  /**
   * Sets the value of the '{@link no.ntnu.tdt4250.componentsdsl.componentsDSL.Port#isProvided <em>Provided</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Provided</em>' attribute.
   * @see #isProvided()
   * @generated
   */
  void setProvided(boolean value);

  /**
   * Returns the value of the '<em><b>Required</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Required</em>' attribute.
   * @see #setRequired(boolean)
   * @see no.ntnu.tdt4250.componentsdsl.componentsDSL.ComponentsDSLPackage#getPort_Required()
   * @model
   * @generated
   */
  boolean isRequired();

  /**
   * Sets the value of the '{@link no.ntnu.tdt4250.componentsdsl.componentsDSL.Port#isRequired <em>Required</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Required</em>' attribute.
   * @see #isRequired()
   * @generated
   */
  void setRequired(boolean value);

} // Port
